/* 
 * File: crossEater6.js
 * web worker contest 2014
 * Author: Piet Jarmatz
 * Email: piet.jarmatz@tum.de
*/

var dir = 0;
var targetdir = Math.floor(Math.random()*4);
var mode = 0;  // cross
var submode = 0; // vert1
var subsubmode = 0; // search1
var stepCount = 0, stepOffset = 0;
var map; 
var x = 0, y=0;
var x1 = 0, y1 = 0;
var minx, miny, maxx, maxy;
var directions = ['up', 'left', 'down',  'right'];
var race_condition = false;
var rotcnt = 1000;
var message = {id: 0, direction: directions[dir]}

// der Worker hat nun 300 ms zur Initialisierung
initMap();

function initMap(){
  map = new Array(101);
  for (var i = 0; i < 101; i++) {
    map[i] = new Array(101);
    for(var j=0; j < 101; j++)
      map[i][j] = -1;
  }  
  minx = maxx = x;
  miny = maxy = y;
}

// erkennt spielfeld-ränder => wallfollow-speedup
function detectWalls(){
  if((maxx-minx+101)%101 == 99){
    for(var i=0; i < 101; i++){
      map[(minx+100)%101][i] = 4;
      map[(maxx+102)%101][i] = 4;
    }
  }
  if((maxy-miny+101)%101 == 99){
    for(var i=0; i < 101; i++){
      map[i][(miny+100)%101] = 4;
      map[i][(maxy+102)%101] = 4;
    }
  }
}

onmessage = function (event) {
  if (event.data.done == false) {
    mapFailedMove();
    if(mode == 0) {   // cross
      switch(subsubmode){
        case 0:  // search1
          dir = turnLeft(dir);
          targetdir = turnAround(targetdir);
          stepOffset = stepCount;
          stepCount = 0;
          subsubmode = 1; 
          break;
        case 1: // search2
          dir = turnLeft(dir);
          subsubmode = 2;
          break;
        case 2: // search2 on line
          dir = turnLeft(dir);
          if(submode == 2 || (submode == 1 && ((2*stepOffset<stepCount?stepCount-stepOffset:stepOffset)<66))){
            mode++;
            x1 = x; y1 = y;
            targetdir = dir;
            detectWalls();
            break;
          }
          targetdir = turnAround(targetdir);
          if(submode==1)
            stepCount = Math.floor(stepOffset/2 - stepCount/(2*stepOffset<stepCount?2:1));
          else
            stepCount = -Math.floor(stepCount/2)+3;
          subsubmode = 3;
          break;
        case 3: // goto center
          dir = turnLeft(dir);
          mode++;
          x1 = x; y1 = y;
          targetdir = dir;
          detectWalls();
      }
    } 
    else {
      if(mode == 1 && !race_condition && dir == targetdir) check_race_condition();
      dir = targetdir;
      if(mode==3 && submode==0){ // search1
        submode = 1;
        stepCount = 0;
        dir = turnLeft(dir);
      }
    }
  }
  else{
    stepCount++;
    mapSuccessfulMove();
    if(mode == 0){ // cross
      updateMinMaxXY();
      if(stepCount == 0){  // found center
          submode++;
          targetdir = turnRight(targetdir);
          subsubmode = 0;
      }
      dir = targetdir;
    }
    else{
      if(mode==1){
        rotcnt += (dir-targetdir+5)%4-1;
        if(x1 == x && y1 == y)
          mode++;
      }
      targetdir = dir;
    }
  }

  if(mode == 1){  // bereiche sichern / umschließen
    if((stepCount%3!=0 || race_condition) && free(turnRight(dir)))
      mapExtraWall(turnRight(dir));
    if(pseudofree(turnRight(dir)))
      dir = turnRight(dir);
    else if(pseudofree(dir)) ;
    else if(pseudofree(turnLeft(dir)))
      dir = turnLeft(dir);
    else
      dir = turnAround(dir);
  }

  else if(mode == 2){ // fill
    if(free(turnRight(dir)))
      dir = turnRight(dir);
    else if(free(dir));
    else if(free(turnLeft(dir))){
      dir = turnLeft(dir);
    }
    else{
      mode++; submode = 0;
      stepCount = 0;
      dir = turnAround(dir);
      targetdir = dir;
    }
  }

  else if(mode == 3){  // leave dead end / area
    if(submode == 0){  // find wall
      if(stepCount == 10){  // find free areas to the right
        stepCount = 0;
        var r=turnRight(dir);
        for (var i = 2; i <20; i++) {
          var m = map[(x+r%2*(r-2)*i+101)%101][(y+(1-r%2)*(1-r)*i+101)%101];
          if(m == 4) break;
          if(m == -1){
            dir = r;
            message.id = event.data.id;
            message.direction = directions[dir];
            postMessage(message);
            return;
          }
        }
      }
      if(free(turnRight(dir)))
        dir = turnRight(dir);
    }
    else if(submode == 1){  // follow wall
      if(stepCount == 10){  // find free areas to the left
        stepCount = 0;
        var l=turnLeft(dir);
        for (var i = 1; i <20; i++) {
          var m = map[(x+l%2*(l-2)*i+101)%101][(y+(1-l%2)*(1-l)*i+101)%101];
          if(m == 4) break;
          if(m == -1){
            dir = l;
            submode = 0;
            message.id = event.data.id;
            message.direction = directions[dir];
            postMessage(message);
            return;
          }
        }
      }
      if(pseudofree(turnRight(dir)))
        dir = turnRight(dir);
      else if(pseudofree(dir));
      else if(pseudofree(turnLeft(dir)))
        dir = turnLeft(dir);
      else
        dir = turnAround(dir);
    }
  }

  message.id = event.data.id;
  message.direction = directions[dir];
  postMessage(message);
};

function mapFailedMove(){
  map[(x+dir%2*(dir-2)+101)%101][(y+(1-dir%2)*(1-dir)+101)%101] = 4;
}

function mapExtraWall(d){
  map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] = 4;
}

function mapSuccessfulMove(){
  x = (x + dir%2*(dir-2) + 101 )%101;
  y = (y + (1-dir%2)*(1-dir) + 101)%101;
  if(mode == 1){
    if(race_condition && map[x][y] != -1) race_condition = false;
    map[x][y] = rotcnt;
  }
  else {
    if(mode == 3 && map[x][y] == -1) {
      mode--;
      dir = turnRight(dir);
    }
    map[x][y] = mode;
  }
}

function updateMinMaxXY(){
  if(x == (minx+100)%101) minx = x; 
  if(x == (maxx+102)%101) maxx = x; 
  if(y == (miny+100)%101) miny = y; 
  if(y == (maxy+102)%101) maxy = y; 
}

function free(d){  
  return map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] == -1;
}

function pseudofree(d){  
  return map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] != 4;
}

function check_race_condition(){
  var m = map[(x+dir%2*(dir-2)*2+101)%101][(y+(1-dir%2)*(1-dir)*2+101)%101];
  if(m>10 && rotcnt-m == 3) race_condition = true;
}

function turnLeft(d){
  return (d + 1) % 4;
}

function turnAround(d){
  return (d + 2) % 4;
}

function turnRight(d){
  return (d + 3) % 4;
}

/*
Done:
  - mode 3 leaving bugfix (cross reflect)
  - spiralfallen-erkennung (race_condition)
  
Todo:

- pfadplanung / baum
- cross 45 Grad drehen
- nextStep buffer 

*/