"use strict";
// http://www.webworkercontest.net
// author: feri
// email: ferenc.hechler@web.de


// KONSTANTEN fuer die Richtungen 

var dirMessage	= [ "up", "left", "down", "right", "error"];
var rotateLeft	= [    1,      2,      3,       0,       4];
var rotateRight	= [    3,      0,      1,       2,       4];
var rotateBack 	= [    2,      3,      0,       1,       4];
var addPos 		= [ -101,     -1,    101,       1,       0];
var addX 		= [    0,     -1,      0,       1,       0];
var addY 		= [   -1,      0,      1,       0,       0];


// MAIN Variables

var mode = 0;		// aktuelles Programm:	 MODE_xxx  

var step = 0;		// Aktueller Schritt

var dir = 4;		// zuletzt gesendete Richtung

var posX = 0;		// aktuelle Position
var posY = 0;
var pos = 10201;    // umgerechnet im Array (101+posY)*101+posX

var minX = 0;		// Grenzen der bekannten Welt
var minY = 0;
var maxX = 0;
var maxY = 0;

var borderMinX = 9999;	// Position der bekannten Grenzwaende (9999 wenn unbekannt)
var borderMinY = 9999;
var borderMaxX = 9999;
var borderMaxY = 9999;

var field = new Int16Array(20402);			// Feld, beginn bei Position 10201 (101x101, siehe pos) 
var searchField = new Uint16Array(20402);	// Suchfeld fuer die Wegsuche 

var moves = new Uint8Array(10000);			// zwischengespeicherte Bewegungen
var movesIndex = 0;

// PRE CALCULATED MOVES

var nextMovesDir = new Int8Array(10000);   	// [-cnt1, dir1, dir2, -cnt3, dir3, ...]  (negative numbers are cnts for the next dir) 
var currentMove = 0;						// currently executed move
var endMove = 0;							// end of pre-claculated move
var lastCalculationPos = 0;					// position, ab der zuletzt der nchste Schritt berechnet wurde

var notifyStepFlag = false;


var rauteProgs = new Int8Array(1600);
var rauteProgNum; 
var rauteProgPos; 
var rauteCtrl;
var rauteBounceCnt;
var rauteLastBounceDir;
//following program on blocked dir
var rauteCtrls = [[ 3,  6, -1, -1],		// 0 -> OL
                  [ 3,  6, -1, -1],		// 1 -> LO
                  [-1,  5,  0, -1],		// 2 -> LU
                  [-1,  5,  0, -1],		// 3 -> UL
                  [-1, -1,  6,  2],		// 4 -> UR
                  [-1, -1,  7,  2],		// 5 -> RU
                  [ 4, -1, -1,  1],		// 6 -> RO
                  [ 4, -1, -1,  1]];	// 7 -> OR



function rautefunc(event) {
	if (event.data.done !== false) {
		moves[movesIndex++] = dir;
		dir = rauteProgs[rauteProgPos++]; 
		postMessage({
			id: event.data.id,
			direction: dirMessage[dir]
		});
	}
	else {
		moves[movesIndex++] = 10+dir;
		if ((--rauteBounceCnt === 0) || (dir === rauteLastBounceDir)) {
			redoMoves();
			startBorderFunc(event);
		}
		else {
			rauteLastBounceDir = rotateBack[dir];
			rauteProgNum = rauteCtrls[rauteProgNum][dir];
			rauteProgPos = rauteProgNum*200;  
			dir = rauteProgs[rauteProgPos++]; 
			postMessage({
				id: event.data.id,
				direction: dirMessage[dir]
			});
		}
	}
}

function startRauteFunc() {
	createRauteProgs(10);
	rauteProgNum = Math.floor(Math.random()*8);
	rauteProgPos = rauteProgNum*200;
	rauteCtrl = rauteCtrls[rauteProgNum];
	rauteBounceCnt = 4;
	rauteLastBounceDir = 4;
	onmessage = rautefunc;
}

function createRauteProgs(dist) {
	createRauteProg(0*200, 0, 1, dist);     // 0 -> OL
	createRauteProg(1*200, 1, 0, dist);		// 1 -> LO
	createRauteProg(2*200, 1, 2, dist);		// 2 -> LU
	createRauteProg(3*200, 2, 1, dist);		// 3 -> UL
	createRauteProg(4*200, 2, 3, dist);		// 4 -> UR
	createRauteProg(5*200, 3, 2, dist);		// 5 -> RU
	createRauteProg(6*200, 3, 0, dist);		// 6 -> RO
	createRauteProg(7*200, 0, 3, dist);		// 7 -> OR
}

function createRauteProg(n, dir1, dir2, dist) {
	var nextDist =Math.floor(Math.random()*(2*dist-2))+1;
	var nextNextDist =2*dist-nextDist;
	var cnt = nextDist-1;
	var di = dir1;
	for (var i=0; i<200; i++) {
		rauteProgs[n+i] = di;
		cnt++;
		if (cnt === nextDist) {
			cnt = 0;
			di = (di===dir1)?dir2:dir1;
			if (di === dir1) {
				if (nextNextDist === 0) {
					nextDist =Math.floor(Math.random()*(2*dist-2))+1;
					nextNextDist =2*dist-nextDist;
				}
				else {
					nextDist = nextNextDist;
					nextNextDist = 0;
				}
			}
		}
	}
}


function redoMoves() {
	for (var n=0; n<movesIndex; n++) {
		dir = moves[n];
		if (dir<10) {
			fillStep();
		}
		else {
			dir -= 10;
			fillBlock();
		}
	}
}


var bdStartStep = 0;
var bdLastF = 0;
var bdSpeed = 2;
var bdCnt = 0;
var bdTurned = false;
var bdRotateFree;
var bdRotateBlocked;

function startBorderFunc(event) {
	if (Math.random()<0.5) {
		bdRotateFree = rotateLeft;
		bdRotateBlocked = rotateRight;
	}
	else {
		bdRotateFree = rotateRight;
		bdRotateBlocked = rotateLeft;
	}
	bdStartStep = step;
	bdLastF = 0;
	bdSpeed = 2;
	bdCnt = 0;
	bdTurned = false;
	onmessage = borderfunc;
	onmessage(event);
}


function borderfunc(event) {
	if (event.data.done) {
		fillStep();
		
		if (bdTurned) {
			bdTurned = false;
			bdLastF = 0;
			bdSpeed = 2;
		}
		var currentF = field[pos]; 
		if ((currentF !== step) && (currentF > bdStartStep)) {
			if (bdLastF === currentF-1) {
				startFillFunc(event);
				return;
			}
		}
		bdLastF = currentF;
		bdCnt++;
		if (bdCnt >= bdSpeed) {
			bdCnt = 0;
			bdSpeed = 2*bdSpeed-1;
			bdTurned = true;
			dir = bdRotateFree[dir];
		}
		else {
			var oldF = setUncheckedBlock(bdRotateFree[dir]);
			if (oldF > 0) {
				dir = bdRotateFree[dir];
			}
		}
	}
	else {
		fillBlock();
		
		if (!bdTurned) {
			bdSpeed = 2;
			bdCnt = 0;
		}
		else {
			bdTurned = false;
		}
		dir = bdRotateBlocked[dir];		
	}
	
	if (isBlocked(dir)) {
		event.data.done = false;
		borderfunc(event);
	}
	else {
		postMessage({
			id: event.data.id,
			direction: dirMessage[dir]
		});
	}
}


function circlefunc(event) {
	dir = rotateLeft[dir];
	postMessage({
		id: event.data.id,
		direction: dirMessage[dir]
	});
}

function startFillFunc(event) {
	onmessage = complexOnMessage;
	createFastfillProgram();
	postMessage({
		id: event.data.id,
		direction: dirMessage[dir]
	});
}

//
// process incoming result.
//
function complexOnMessage(event) {
	
	var unblocked = event.data.done;
	
	if (unblocked) {
		fillStep();
		if (notifyStepFlag) {
			notifyStep();
		}
	}
	else {
		fillBlock();
		endMove = 0;
	}

	while (true) {

		if (unblocked) {
			if (currentMove < endMove) {
				doCalculatedMoves();
			}
		}
		else {
			notifyBlocked();
		}
		
		if (!isBlocked(dir)) {
			break;
		}
		unblocked = false;
		endMove = 0;
	}
	
	postMessage({
		id: event.data.id,
		direction: dirMessage[dir]
	});
}




// -------- //
// NOTIFIES //
// -------- //


function notifyStep() {
	switch(mode) {

	// MODE_CIRCLE
	case 5:
		circleStep();
		break;
		
	// MODE_FASTFILL
	case 9:
		fastfillDoStep();
		break;

	}
}

function notifyMoveFinished() {
	switch(mode) {
	
	// MODE_SEARCHFREE
	case 7:
		searchfreeMoveFinished();
		break;

	// MODE_FASTFILL
	case 9:
		fastfillMoveFinished();
		break;

	}
}

function notifyBlocked() {
	switch(mode) {

	// MODE_CIRCLE
	case 5:
		circleBlocked();
		break;
		
	// MODE_SEARCHFREE
	case 7:
		searchfreeBlocked();
		break;
		
	// MODE_FASTFILL
	case 9:
		fastfillBlocked();
		break;

	}
}



// -------------- //
// CALC NEXT MOVE //
// -------------- //

function calcNextMove() {
	// zur Sicherheit alles zuruecksetzen
	clearMoves();
	notifyStepFlag = false;

	switch (mode) {
	// MODE_CIRCLE:
	case 5:
		createCircleProgram();
		break;

	// MODE_SEARCHFREE:
	case 7:
		createFastfillProgram();
		break;

	// MODE_FASTFILL:
	case 9:
		createSearchfreeProgram();
		break;

	}
}


// --------- //
// FINISHING //
//---------- //

function createFinishingProgram() {
	var cnt = replaceAllUncheckedBlocks();
	if (cnt === 0) {
		createCircleProgram();
	}
	else {
		createSearchfreeProgram();
	}
}

function replaceAllUncheckedBlocks() {
	var cnt = 0;
	var pLine = 10201+101*minY+minX;
	var p;
	for (var y=minY; y<=maxY; y++) {
		p = pLine; 
		for (var x=minX; x<=maxX; x++) {
			if (field[p] === -2) {
				// TODO: groesse der zusammenhangenden frei werdenden Flaeche bewerten und sortieren
				field[p] = 0;
				searchField[p] = 0;
				cnt++;
			}
			p++;
		}
		pLine += 101;
	}
	return cnt;
}


// --------------- //
// SEARCHFREE PROG //
// --------------- //

function createSearchfreeProgram() {
	mode = 7; // MODE_SEARCHFREE;
	notifyStepFlag = false;
	
	var bestFirstDi = 4;
	var bestDi = 4;
	var bestCnt = 15;
	var cnt = 0;
	var di = 0;
	var firstDiList = [rotateLeft[di], rotateRight[di], 4];
	
	for (var n=0; n<firstDiList.length; n++) {
		var firstDi = firstDiList[n];
		if (!isBlocked(firstDi)) {
			for (di=0; di<4; di++) {
				cnt = searchFree(di, addPos[firstDi], bestCnt);
				if (firstDi !== 4) {
					cnt ++;
				}
				if (cnt<bestCnt) {
					bestFirstDi = firstDi;
					bestDi = di;
					bestCnt = cnt;
				}
			}
		}
	}
	if (bestDi === 4) {
		fullSearch();
		return;
	}
	if (bestCnt <= 1) {
		calcNextMove();
		return;
	}
	if (bestFirstDi !== 4) {
		createMove(bestFirstDi);
		addRepeatedMove(bestDi, bestCnt-2);
	}
	else {
		createRepeatedMove(bestDi, bestCnt-1);
	}
	startCalculatedMoves();
}


function searchFree(di, poOffs, maxCnt) {
	var addPo = addPos[di];
	var po = pos+poOffs;
	for (var cnt=1; cnt<maxCnt; cnt++) {
		po += addPo;
		if (field[po] === 0) {
			return cnt;
		}
		if (field[po] < 0) {
			return 9999;
		}
	}
	return 9999;
}

var sfStartStep = 1;

function fullSearch() {
	sfStartStep++;
	if (sfStartStep > 64500) {
		searchField = new Uint16Array(20402);
		sfStartStep = 2;
	} 
	var p = 0;
	var currentPosList = [pos];
	searchField[pos] = sfStartStep;
	for (var n=1; n<1000; n++) {
		var nextPosList = [];
		for (var i=0; i<currentPosList.length; i++) {
			for (var di=0; di<4; di++) {
				p = currentPosList[i]+addPos[di];
				if (searchField[p] < sfStartStep) {
					if (field[p] === 0) {
						searchField[p] = sfStartStep+n;
						calcSearchMoves(p, sfStartStep);
						sfStartStep += n+1;
						startCalculatedMoves();
						return;
					}
					if (field[p] < 0) {
						searchField[p] = 65535;
					}
					else {
						searchField[p] = sfStartStep+n;
						nextPosList.push(p);
					}
				}
			}
		}
		if (nextPosList.length === 0) {
			break;
		}
		currentPosList = nextPosList;
	}
	sfStartStep += 1001;
	createFinishingProgram();
}


function calcSearchMoves(startPos, sfStartStep) {
	clearMoves();
	var cnt = searchField[startPos]-sfStartStep;
	var p = startPos;
	var p2 = 0;
	for (var n=cnt-1; n>=0; n--) {
		for (var di=0; di<4; di++) {
			p2=p+addPos[di];
			if (searchField[p2] === sfStartStep+n) {
				nextMovesDir[n] = rotateBack[di];
				p = p2;
				break;
			}
		}
	}
	endMove = cnt-1;
}



function searchfreeBlocked() {
	createCircleProgram();
}

function searchfreeMoveFinished() {
	calcNextMove();
}




// ------------- //
// FASTFILL PROG //
// ------------- //

var fafiRotateFree;
var fafiRotateBlocked;
var fafiStartStep;

function createFastfillProgram() {
	mode = 9; // MODE_FASTFILL;
	notifyStepFlag = true;
	if (Math.random()<0.5) {
		fafiRotateFree = rotateLeft;
		fafiRotateBlocked = rotateRight;
	}
	else {
		fafiRotateFree = rotateRight;
		fafiRotateBlocked = rotateLeft;
	}
	fafiStartStep = step;
	fastfillDoStep();
}

function fastfillDoStep() {
	if (isFree(fafiRotateFree[dir])) {
		dir = fafiRotateFree[dir];
		return;
	}
	if (isFree(dir)) {
		return;
	}
	if (isFree(fafiRotateBlocked[dir])) {
		dir = fafiRotateBlocked[dir];
		return;
	}
	if (isFree(rotateBack[dir])) {
		dir = rotateBack[dir];
		return;
	}
	calcNextMove();
}

function fastfillBlocked() {
	fastfillDoStep();
}

function fastfillMoveFinished() {
	fastfillDoStep();
}


// ----------- //
// CIRCLE PROG //
// ----------- //

function createCircleProgram() {
	mode = 5; // MODE_CIRCLE;
	notifyStepFlag = true;
	circleStep();
}

function circleStep() {
	dir = rotateLeft[dir];
}

function circleBlocked() {
	circleStep();
}


//-------------------- //
// PRECALCULATED MOVES //
//-------------------- //

function clearMoves() {
	currentMove = 0;
	endMove = 0;
	lastCalculationPos = 0;
}

function createMove(di) {
	currentMove = 0;
	endMove = 1;
	lastCalculationPos = 0;
	nextMovesDir[0] = di;
}

function createRepeatedMove(di, cnt) {
	if (cnt > 0) {
		currentMove = 0;
		endMove = 2;
		lastCalculationPos = 0;
		nextMovesDir[0] = -cnt;
		nextMovesDir[1] = di;
	}
}

function addMove(di) {
	nextMovesDir[endMove] = di;
	endMove++;
}

function addRepeatedMove(di, cnt) {
	if (cnt > 0) {
		nextMovesDir[endMove] = -cnt;
		endMove++;
		nextMovesDir[endMove] = di;
		endMove++;
	}
}



function startCalculatedMoves() {
	addMove(4);  // ende marker
	doCalculatedMoves();
}



//
// setze "dir" auf die naechste hinterlegte richtung. 
// gibt es keine weiteren Zuege mehr, 
// dann wird notifyMoveFinished() aufgerufen.
// 
function doCalculatedMoves() {
	if (lastCalculationPos === pos) {
		return;
	}
	lastCalculationPos = pos;
	var di = nextMovesDir[currentMove];
	if (di >= 0) {
//		log("calculated move "+currentMove+": "+di);
		currentMove++;
		if (di === 4) {
			notifyMoveFinished();
		}
		else {
			dir = di;
		}
	}
	else {
		var cnt = di+1;
		dir = nextMovesDir[currentMove+1];
		if (cnt === 0) {
			currentMove = currentMove+2;
		}
		else {
			nextMovesDir[currentMove] = cnt;
		}
	}
}



// --------------- //
// Hilfsfunktionen //
// --------------- //


function getRandomDirection() {
  return Math.floor(Math.random()*4);
}


function turnLeftOrRight(di) {
	return getRotateLeftOrRight()[di];
}

function getRotateLeftOrRight() {
	if (Math.random()<0.5) {
		return rotateLeft;
	}
	return rotateRight;
}


// ----------------- //
// FIELD beschreiben //
// ----------------- //


function initFieldArray() {
	posX = 0;
	posY = 0;
	pos = 10201;
	step = 1;
	field[pos] = step;
}

function fillStep() {
	step++;
	switch (dir) {
	case 0:
		posY -= 1;
		pos -= 101;
		if (field[pos]===0) {
			field[pos] = step;
		}
		break;
	case 1:
		posX -= 1;
		pos -= 1;
		if (field[pos]===0) {
			field[pos] = step;
		}
		break;
	case 2:
		posY += 1;
		pos += 101;
		if (field[pos]===0) {
			field[pos] = step;
		}
		break;
	case 3:
		posX += 1;
		pos += 1;
		if (field[pos]===0) {
			field[pos] = step;
		}
		break;
	default: 
		break;
	}
}

function fillBlock() {
	switch (dir) {
	case 0:
		field[pos-101] = -1;
		if (posY < minY) {
			minY = posY;
			if (maxY-minY === 99) {
				borderMinY = minY;
				borderMaxY = maxY;
			}
		}
		break;
	case 1:
		field[pos-1] = -1;
		if (posX < minX) {
			minX = posX;
			if (maxX-minX === 99) {
				borderMinX = minX;
				borderMaxX = maxX;
			}
		}
		break;
	case 2:
		field[pos+101] = -1;
		if (posY > maxY) {
			maxY = posY;
			if (maxY-minY === 99) {
				borderMinY = minY;
				borderMaxY = maxY;
			}
		}
		break;
	case 3:
		field[pos+1] = -1;
		if (posX > maxX) {
			maxX = posX;
			if (maxX-minX === 99) {
				borderMinX = minX;
				borderMaxX = maxX;
			}
		}
		break;
	default: 
		break;
	}
}

function setUncheckedBlock(di) {
	var p = pos+addPos[di];
	var f = field[p];
	if (f === 0) {
		field[p] = -2;
	}
	return f;
}


// ----------- //
// FIELD lesen //
// ----------- //


function isFree(di) {
	return (field[pos+addPos[di]] === 0);
}

function isOwn(di) {
	return (field[pos+addPos[di]] > 0);
}

function isBlocked2(di1, di2) {
	return (field[pos+addPos[di1]+addPos[di2]] < 0);
}

function isBlocked(di) {
	var f = field[pos+addPos[di]];
	if (f === 0) {
		switch(di) {
		case 0:
			if (borderMinY === posY) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 1:
			if (borderMinX === posX) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 2:
			if (borderMaxY === posY) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 3:
			if (borderMaxX === posX) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		}
	}
	return (f < 0);
}


// ---- //
// INIT //
//---- //



init();

function init() {
	initFieldArray();
	startRauteFunc();
}



