// http://www.webworkercontest.net/game.php
// author: feri
// email: ferenc.hechler@web.de

var dir = 4;

var addPos = [-101, 1, 101, -1, 0];

var addX = [0, 1, 0, -1, 0];
var addY = [-1, 0, 1, 0, 0];

var wrapDir = [0, 1, 2, 3, 0, 1, 2];

var rotateRight  = [1, 2, 3, 0];
var rotateBack  = [2, 3, 0, 1];
var rotateLeft = [3, 0, 1, 2];

var dirMessage = ["up", "left", "down", "right", "error"];

var mode = 0;   
               
var minX = 0;
var minY = 0;
var maxX = 0;
var maxY = 0;

var borderMinX = 9999;
var borderMinY = 9999;
var borderMaxX = 9999;
var borderMaxY = 9999;

var posX = 0;
var posY = 0;

var cnt1 = 0;
var cnt2 = 0;
var cnt3 = 0;
var cnt4 = 0;
var cnt5 = 0;

var dir1 = 4;
var dir2 = 4;
var cntWalls = 0;
var lastWallMode = 0;
var cntDir = 0;

var field = new Int16Array(20402);
var searchField = new Uint16Array(20402);

onmessage = function (event) {

	if (!event.data.done) {
		mode = mode + 1;
	}
	
	switch(mode) {
	// INIT: select random direction, continue with GO dir1
	case 1:
		fillEmptyArray();
		dir1 = getRandomDirection();	
		dir2 = turnLeftOrRight(dir1);	
		dir = dir1;
		cntWalls = 0;
		cntDir = 0;
		lastWallMode = 0;
		mode = 100; 	
		break;

	case 10: 
	case 11:
		dir = 0;  // just return as fast as possible
		break;
		
	case 20: 
	case 21:
		// dir = 4;  // do not move
		dir = 0;  // just do a quick move to consume steps
		break;
		
	   
	// --- GO dir1 ---
	case 100:  
		fillStep(dir);
		cntDir++;
		if (cntDir === 10) {
			cntDir = 0;
			mode = 110;
			dir = dir2;
			break;
		}
		break;
	case 101:  
		fillBlock(dir);
		cntWalls++;
		if ((cntWalls === 5) || (lastWallMode === 101)){
			turnX = dir1;
			calcNextMove();
			break;
		}
		lastWallMode = 101;
		dir1 = rotateBack[dir1];
		dir = dir1;
		cntDir = 9;
		mode = 100;
		break;
		
	// --- GO dir2 ---
	case 110:  
		fillStep(dir);
		cntDir++;
		if (cntDir === 10) {
			cntDir = 0;
			mode = 100;
			dir = dir1;
			break;
		}
		break;
	case 111:  
		fillBlock(dir);
		cntWalls++;
		if ((cntWalls === 5) || (lastWallMode === 111)){
			turnX = dir2;
			calcNextMove();
			break;
		}
		lastWallMode = 111;
		dir2 = rotateBack[dir2];
		dir = dir2;
		cntDir = 9;
		mode = 110;
		break;
		
		
	case 1000:  
		fillStep(dir);
		calcNextMove();
		break;
	case 1001:  
		fillBlock(dir);
		calcNextMove();
		break;

	case 1100:  
		fillStep(dir);
		doLabyMoveOK();
		break;
	case 1101:  
		fillBlock(dir);
		mode = 1100;
		doLabyMoveBlocked();
		break;
		
	case 1200:  
		fillStep(dir);
		doSpiralMoveOK();
		break;
	case 1201:  
		fillBlock(dir);
		mode = 1200;
		doSpiralMoveBlocked();
		break;
		
	case 1300:  
		fillStep(dir);
		doSearchMoveOK();
		break;
	case 1301:  
		fillBlock(dir);
		mode = 1300;
		doSearchMoveBlocked();
		break;
		
		
	default: 
		// dir = 4;	// ERROR
		dir = 0;	// just any move 
		mode = 20;
		break;
	}

	
	// Teilt dem Hauptprogramm die neue
	// Richtung mit. Die Richtung wird
	// mit dem Feld 'direction' gesendet.
	// Die zu wiederholende Id wird mit
	// dem Feld 'id' gesendet.
	postMessage({
		id: event.data.id,
		direction: dirMessage[dir]
	});
};



// --------- //
// MAIN PROG //
// --------- //


var prog = 0;
var nextSpiralDir = 4;

function calcNextMove() {
	switch (prog) {
	case 0:
		prog = 1;
		createLabyrinthProgram(turnX);
		nextSpiralDir = rotateBack[turnX];
		break;
	case 1: 
		prog = 2;
		createSpiralProgram(nextSpiralDir);
		break;
	case 2:
		prog = 34;
		createSearchProgram();
		break;
	case 3: 
		prog = 2;
		createSpiralProgram(dir);
		break;
	case 4: 
		dir = 0;	// just answer anything fast
		mode = 10;
		break;
		
	case 34: 
		prog = (searchNothingFound ? 4 : 3);
		nextSpiralDir = dir;
		calcNextMove();
		break;
		
	default: 
		break;
	}
}


// --------- //
// PROG LABY //
// --------- //


var labyDir = 0;
var labyMode = 0;
var labyRotateFree = rotateLeft;
var labyRotateBlocked = rotateRight;
var labyStartPosX = 0;
var labyStartPosY = 0;
var labyStartDir = 0;

function createLabyrinthProgram(di) {
	labyDir = di;
	if (Math.random()<0.5) {
		labyRotateFree = rotateLeft;
		labyRotateBlocked = rotateRight;
	}
	else {
		labyRotateFree = rotateRight;
		labyRotateBlocked = rotateLeft;
	}	
	mode = 1100;
	labyMode = 1;
	doLabyMoveOK();
}

function doLabyMoveOK() {
	switch (labyMode) {
	case 1:
		dir = labyDir;
		labyMode = 100;
		break;

	// GO FORWARD (search first block)
	case 100:
		if (isBlocked(dir)) {
			doLabyMoveBlocked();
			break;
		}
		break;
		
	// TURN BLOCKED
	case 200:
		dir = labyRotateFree[dir];
		if (isBlocked(dir)) {
			doLabyMoveBlocked();
			break;
		}
		break;
		
	default: 
		break;
	}
}

function doLabyMoveBlocked() {
	switch (labyMode) {
	// first block found, start following blocks
	case 100:
		labyStartPosX = posX;
		labyStartPosY = posY;
		labyStartDir = dir;
		dir = labyRotateBlocked[dir];
		labyMode = 200;
		break;
		
	// TURN BLOCKED
	case 200:
		if ((posX == labyStartPosX) && (posY == labyStartPosY) && (labyStartDir == dir)) {
			calcNextMove();
			break;
		}
		dir = labyRotateBlocked[dir];
		break;
		
	default: 
		break;
	}
}


// ----------- //
// PROG SPIRAL //
// ----------- //


var spiralStartDir = 4;
var spiralMode = 0;

function createSpiralProgram(startDir) {
	spiralStartDir = startDir;
	spiralMode = 1;
	mode = 1200;
	doSpiralMoveOK();
}


function doSpiralMoveOK() {
	switch (spiralMode) {
	case 1:
		dir = spiralStartDir;
		spiralMode = 100;
		break;

	// GO UP
	case 100:
		if (isFree(rotateRight[dir])) {
			dir = rotateRight[dir];
			break;
		}
		if (isFree(dir)) {
			break;
		}
		if (isFree(rotateLeft[dir])) {
			dir = rotateLeft[dir];
			break;
		}
		if (isFree(rotateBack[dir])) { // kann eigentlich nicht vorkommen, eventuell im allerersten Zug.
			dir = rotateBack[dir];
			break;
		}
		calcNextMove();
		break;
		
	default: 
		break;
	}
}


function doSpiralMoveBlocked() {
	switch (spiralMode) {
	case 100:
		dir = rotateLeft[dir];
		break;
		
	default: 
		break;
	}
}

function isFree(di) {
	return (field[pos+addPos[di]] === 0);
}


function isBlocked(di) {
	var f = field[pos+addPos[di]];
	if (f === 0) {
		switch(di) {
		case 0:
			if (borderMinY === posY) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 1:
			if (borderMaxX === posX) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 2:
			if (borderMaxY === posY) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		case 3:
			if (borderMinX === posX) {
				field[pos+addPos[di]] = -1;
				f = -1;
			}
			break;
		default:
			break;
		}
	}
	return (f === -1);
}


// ----------- //
// PROG SEARCH //
// ----------- //

var searchMoves = [];
var searchMoveIndex = 0;
var searchDir = 0;
var searchCnt = 0;
var searchMode = 0;
var searchNothingFound = false;

function createSearchProgram() {
	var bestFirstDi = 4;
	var bestDi = 4;
	var bestCnt = 15;
	var cnt = 0;
	var di = 0;
	var firstDiList = [rotateLeft[di], rotateRight[di], 4];
	
	for (var n=0; n<firstDiList.length; n++) {
		var firstDi = firstDiList[n];
		if (!isBlocked(firstDi)) {
			for (di=0; di<4; di++) {
				cnt = searchFree(di, addPos[firstDi], bestCnt);
				if (firstDi !== 4) {
					cnt ++;
				}
				if (cnt<bestCnt) {
					bestFirstDi = firstDi;
					bestDi = di;
					bestCnt = cnt;
				}
			}
		}
	}
	if (bestDi === 4) {
		fullSearch();
		return;
	}
	if (bestCnt <= 1) {
		calcNextMove();
		return;
	}
	searchMoves = [];
	if (bestFirstDi !== 4) {
		searchMoves[0] = bestFirstDi;
		searchMoves[1] = 1;
		searchMoves[2] = bestDi;
		searchMoves[3] = bestCnt-2;
	}
	else {
		searchMoves[0] = bestDi;
		searchMoves[1] = bestCnt-1;
	}
	searchMoveIndex = 0;
	searchMode = 1;
	mode = 1300;
	doSearchMoveOK();
}

var sfStartStep = 1;

function fullSearch() {
	sfStartStep++;
	if (sfStartStep > 64500) {
		searchField = new Uint16Array(20402);
		sfStartStep = 2;
	} 
	var p = 0;
	var currentPosList = [pos];
	searchField[pos] = sfStartStep;
	for (var n=1; n<1000; n++) {
		var nextPosList = [];
		for (var i=0; i<currentPosList.length; i++) {
			for (var di=0; di<4; di++) {
				p = currentPosList[i]+addPos[di];
				if (searchField[p] < sfStartStep) {
					if (field[p] === 0) {
						searchField[p] = sfStartStep+n;
						calcSearchMoves(p, sfStartStep);
						searchMoveIndex = 0;
						searchMode = 1;
						mode = 1300;
						sfStartStep += n;
						doSearchMoveOK();
						return;
					}
					if (field[p] === -1) {
						searchField[p] = 65535;
					}
					else {
						searchField[p] = sfStartStep+n;
						nextPosList.push(p);
					}
				}
			}
		}
		if (nextPosList.length === 0) {
			break;
		}
		currentPosList = nextPosList;
	}
	searchNothingFound = true;
	sfStartStep += 1000;
	calcNextMove();
}


function calcSearchMoves(startPos, sfStartStep) {
	var cnt = searchField[startPos]-sfStartStep;
	searchMoves = [];
	var p = startPos;
	var p2 = 0;
	for (var n=cnt-1; n>=0; n--) {
		for (var di=0; di<4; di++) {
			p2=p+addPos[di];
			if (searchField[p2] === sfStartStep+n) {
				searchMoves[(2*n)]=rotateBack[di];
				searchMoves[(2*n+1)]=1;
				p = p2;
				break;
			}
		}
	}
}


function doSearchMoveOK() {
	switch (searchMode) {
	case 1:
		searchDir = searchMoves[searchMoveIndex];
		searchCnt = searchMoves[searchMoveIndex+1];
		dir = searchDir;
		searchMode = 100;
		break;

	// GO UP
	case 100:
		searchCnt -= 1;
		if (searchCnt <= 0) {
			searchMoveIndex += 2;
			if (searchMoveIndex >= searchMoves.length) {
				calcNextMove();
				break;
			}
			searchDir = searchMoves[searchMoveIndex];
			searchCnt = searchMoves[searchMoveIndex+1];
			dir = searchDir;
			break;
		}
		break;
		
	default: 
		break;
	}
}


function doSearchMoveBlocked() {
	calcNextMove();
}

function searchFree(di, poOffs, maxCnt) {
	var addPo = addPos[di];
	var po = pos+poOffs;
	for (var cnt=1; cnt<maxCnt; cnt++) {
		po += addPo;
		if (field[po] === 0) {
			return cnt;
		}
		if (field[po] == -1) {
			return 9999;
		}
	}
	return 9999;
}



// --------------- //
// Hilfsfunktionen //
// --------------- //


function getRandomDirection() {
  return Math.floor(Math.random()*4);
}


function turnLeftOrRight(di) {
	if (Math.random()<0.5) {
		return rotateLeft[di];
	}
	return rotateRight[di];
}


var step = 0;


function fillEmptyArray() {
	posX = 0;
	posY = 0;
	pos = 10201;
	step = 1;
	field[pos] = step;
}

//function fill(di, cnt) {
//	if (di != 4) {
//		posX += cnt*addX[di];
//		posY += cnt*addY[di];
//		var incPos = addPos[di];
//		for (var i=0; i<cnt; i++) {
//			pos += incPos;
//			step++;
//			field[pos] = step;
//		}
//		minX = Math.min(minX, posX);
//		maxX = Math.max(maxX, posX);
//		minY = Math.min(minY, posY);
//		maxY = Math.max(maxY, posY);
//	}
//}

function fillStep(di) {
	step++;
	switch (di) {
	case 0:
		posY -= 1;
		pos -= 101;
		field[pos] = step;
		break;
	case 1:
		posX += 1;
		pos += 1;
		field[pos] = step;
		break;
	case 2:
		posY += 1;
		pos += 101;
		field[pos] = step;
		break;
	case 3:
		posX -= 1;
		pos -= 1;
		field[pos] = step;
		break;
	default: 
		break;
	}
}

function fillBlock(di) {
	switch (di) {
	case 0:
		field[pos-101] = -1;
		if (posY < minY) {
			minY = posY;
			if (maxY-minY === 99) {
				borderMinY = minY;
				borderMaxY = maxY;
			}
		}
		break;
	case 1:
		field[pos+1] = -1;
		if (posX > maxX) {
			maxX = posX;
			if (maxX-minX === 99) {
				borderMinX = minX;
				borderMaxX = maxX;
			}
		}
		break;
	case 2:
		field[pos+101] = -1;
		if (posY > maxY) {
			maxY = posY;
			if (maxY-minY === 99) {
				borderMinY = minY;
				borderMaxY = maxY;
			}
		}
		break;
	case 3:
		field[pos-1] = -1;
		if (posX < minX) {
			minX = posX;
			if (maxX-minX === 99) {
				borderMinX = minX;
				borderMaxX = maxX;
			}
		}
		break;
	default: 
		break;
	}
}

