/* 
 * File: wallE.js
 * (crossEater5 ohne Kreuz-Eröffnung)
 * web worker contest 2014
 * Author: Piet Jarmatz
 * Email: piet.jarmatz@tum.de
*/

var dir = 0;
var targetdir = Math.floor(Math.random()*4);
var mode = 0;  
var submode = 0;
var subsubmode = 0;
var stepCount = 0, stepOffset = 0;
var map; 
var x = 0, y=0;
var x1 = 0, y1 = 0;
var directions = ['up', 'left', 'down',  'right'];

initMap();

function initMap(){
  map = new Array(101);
  for (var i = 0; i < 101; i++) {
    map[i] = new Array(101);
    for(var j=0; j < 101; j++)
      map[i][j] = -1;
  }  
}

onmessage = function (event) {
  if (event.data.done == false) {
    mapFailedMove();
    if(mode == 0) { 
      dir = turnLeft(dir);
      mode++;
      x1 = x; y1 = y;
      targetdir = dir;
    } 
    else {
      dir = targetdir;
    }
    if(mode==3 && submode==0){ // search1
      submode = 1;
      stepCount = 0;
      dir = turnLeft(dir);
    }
  }
  else{
    stepCount++;
    mapSuccessfulMove();
    if(mode == 0)
      dir = targetdir;
    else
      targetdir = dir;
    if(mode==1)
      if(x1 == x && y1 == y)
        mode++;
  }

  if(mode == 1){  // bereiche sichern / umschließen
    if(stepCount%3!=0 && free(turnRight(dir)))
      mapExtraWall(turnRight(dir));
    if(pseudofree(turnRight(dir)))
      dir = turnRight(dir);
    else if(pseudofree(dir)) ;
    else if(pseudofree(turnLeft(dir)))
      dir = turnLeft(dir);
    else
      dir = turnAround(dir);
  }

  else if(mode == 2){ // fill
    if(free(turnRight(dir)))
      dir = turnRight(dir);
    else if(free(dir));
    else if(free(turnLeft(dir))){
      dir = turnLeft(dir);
    }
    else{
      mode++; submode = 0;
      stepCount = 0;
      dir = turnAround(dir);
      targetdir = dir;
    }
  }

  else if(mode == 3){  // leave dead end / area
    if(submode == 0){  // find wall
      if(stepCount == 10){  // find free areas to the right
        stepCount = 0;
        var r=turnRight(dir);
        for (var i = 2; i <20; i++) {
          var m = map[(x+r%2*(r-2)*i+101)%101][(y+(1-r%2)*(1-r)*i+101)%101];
          if(m == 4) break;
          if(m == -1){
            dir = r;
            postMessage({
              id: event.data.id,
              direction: directions[dir]
            });
            return;
          }
        }
      }
      if(free(turnRight(dir)))
        dir = turnRight(dir);
    }
    else if(submode == 1){  // follow wall
      if(stepCount == 10){  // find free areas to the left
        stepCount = 0;
        var l=turnLeft(dir);
        for (var i = 1; i <20; i++) {
          var m = map[(x+l%2*(l-2)*i+101)%101][(y+(1-l%2)*(1-l)*i+101)%101];
          if(m == 4) break;
          if(m == -1){
            dir = l;
            submode = 0;
            postMessage({
              id: event.data.id,
              direction: directions[dir]
            });
            return;
          }
        }
      }
      if(pseudofree(turnRight(dir)))
        dir = turnRight(dir);
      else if(pseudofree(dir));
      else if(pseudofree(turnLeft(dir)))
        dir = turnLeft(dir);
      else
        dir = turnAround(dir);
    }
  }

  postMessage({
    id: event.data.id,
    direction: directions[dir]
  });
};

function mapFailedMove(){
  map[(x+dir%2*(dir-2)+101)%101][(y+(1-dir%2)*(1-dir)+101)%101] = 4;
}

function mapExtraWall(d){
  map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] = 4;
}

function mapSuccessfulMove(){
  x = (x + dir%2*(dir-2) + 101 )%101;
  y = (y + (1-dir%2)*(1-dir) + 101)%101;
  if(mode==3 && map[x][y]<1) {
    mode--;
    dir = turnRight(dir);
  }
  map[x][y] = mode;
}

function free(d){  
  return map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] == -1;
}

function pseudofree(d){  
  return map[(x+d%2*(d-2)+101)%101][(y+(1-d%2)*(1-d)+101)%101] != 4;
}

function turnLeft(d){
  return (d + 1) % 4;
}

function turnAround(d){
  return (d + 2) % 4;
}

function turnRight(d){
  return (d + 3) % 4;
}